"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.queryJoinGroupRequests = exports.listJoinGroupRequests = exports.rejectJoinGroupRequests = exports.approveJoinGroupRequests = exports.WebhookIdentityType = exports.SortOrder = exports.OwnershipFilter = exports.ItemsToUpdate = exports.ViolationType = exports.RequestStatus = void 0;
const transform_error_1 = require("@wix/sdk-runtime/transform-error");
const query_builder_1 = require("@wix/sdk-runtime/query-builder");
const rename_all_nested_keys_1 = require("@wix/sdk-runtime/rename-all-nested-keys");
const ambassadorWixSocialGroupsV2JoinGroupRequest = __importStar(require("./social-groups-v2-join-group-request-join-group-requests.http.js"));
// @ts-ignore
const transform_paths_1 = require("@wix/sdk-runtime/transformations/transform-paths");
var RequestStatus;
(function (RequestStatus) {
    /** Pending group request. */
    RequestStatus["PENDING"] = "PENDING";
    /** Approved group request. */
    RequestStatus["APPROVED"] = "APPROVED";
    /** Rejected group request. */
    RequestStatus["REJECTED"] = "REJECTED";
    /** Canceled group request. */
    RequestStatus["CANCELED"] = "CANCELED";
})(RequestStatus || (exports.RequestStatus = RequestStatus = {}));
var ViolationType;
(function (ViolationType) {
    ViolationType["NONE"] = "NONE";
    ViolationType["NOT_LOGGED_IN"] = "NOT_LOGGED_IN";
    ViolationType["ALREADY_JOINED"] = "ALREADY_JOINED";
    ViolationType["SECRET_GROUP"] = "SECRET_GROUP";
    ViolationType["EVENTS"] = "EVENTS";
    ViolationType["PRICING_PlANS"] = "PRICING_PlANS";
    ViolationType["MEMBERSHIP_QUESTIONS"] = "MEMBERSHIP_QUESTIONS";
    ViolationType["ADMIN_APPROVAL"] = "ADMIN_APPROVAL";
})(ViolationType || (exports.ViolationType = ViolationType = {}));
var ItemsToUpdate;
(function (ItemsToUpdate) {
    /** Take into account only items which are listed in the request. */
    ItemsToUpdate["BY_ID"] = "BY_ID";
    /** Update all items. */
    ItemsToUpdate["ALL_ITEMS"] = "ALL_ITEMS";
})(ItemsToUpdate || (exports.ItemsToUpdate = ItemsToUpdate = {}));
var OwnershipFilter;
(function (OwnershipFilter) {
    /** All items. */
    OwnershipFilter["ALL"] = "ALL";
    /** Items for the current site member. */
    OwnershipFilter["CURRENT_MEMBER"] = "CURRENT_MEMBER";
})(OwnershipFilter || (exports.OwnershipFilter = OwnershipFilter = {}));
var SortOrder;
(function (SortOrder) {
    SortOrder["ASC"] = "ASC";
    SortOrder["DESC"] = "DESC";
})(SortOrder || (exports.SortOrder = SortOrder = {}));
var WebhookIdentityType;
(function (WebhookIdentityType) {
    WebhookIdentityType["UNKNOWN"] = "UNKNOWN";
    WebhookIdentityType["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
    WebhookIdentityType["MEMBER"] = "MEMBER";
    WebhookIdentityType["WIX_USER"] = "WIX_USER";
    WebhookIdentityType["APP"] = "APP";
})(WebhookIdentityType || (exports.WebhookIdentityType = WebhookIdentityType = {}));
/**
 * Approves pending join group requests.
 * Group managers always have access to this functionality. In some cases, site owners will allow group members to use this functionality as well.
 * @param memberIds - IDs of the site members to approve.
 * @public
 * @requiredField groupId
 * @requiredField memberIds
 * @param groupId - ID of the group requested to join.
 * @fqn wix.social.groups.api.v2.JoinGroupRequestsService.ApproveJoinGroupRequests
 */
async function approveJoinGroupRequests(groupId, memberIds) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        groupId: groupId,
        memberIds: memberIds,
    });
    const reqOpts = ambassadorWixSocialGroupsV2JoinGroupRequest.approveJoinGroupRequests(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { groupId: '$[0]', memberIds: '$[1]' },
            singleArgumentUnchanged: false,
        }, ['groupId', 'memberIds']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.approveJoinGroupRequests = approveJoinGroupRequests;
/**
 * Rejects pending join group requests.
 * Group managers always have access to this functionality. In some cases, site owners will allow group members to use this functionality as well.
 * @param rejections - Rejection info.
 * @public
 * @requiredField groupId
 * @requiredField rejections
 * @param groupId - ID of the group requested to join.
 * @fqn wix.social.groups.api.v2.JoinGroupRequestsService.RejectJoinGroupRequests
 */
async function rejectJoinGroupRequests(groupId, rejections) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        groupId: groupId,
        rejections: rejections,
    });
    const reqOpts = ambassadorWixSocialGroupsV2JoinGroupRequest.rejectJoinGroupRequests(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { groupId: '$[0]', rejections: '$[1]' },
            singleArgumentUnchanged: false,
        }, ['groupId', 'rejections']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.rejectJoinGroupRequests = rejectJoinGroupRequests;
/**
 * Lists requests to join a group.
 *
 * > **Note:** This function is only relevant for private groups.
 *
 * The `listjoinGroupRequests()` function returns a Promise that resolves to a list of up to 100 requests to join a group. Sorts by default to `_createdDate` in descending order.
 * Only group admins can see requests to join their group. Site members can access their own join requests in their site.
 *
 * > **Notes:**
 * <!-- > + If the `suppressAuth` option is set to `true`, all permissions are overwritten, and all site members (including non-group members) can see requests to join a group. -->
 * @public
 * @requiredField groupId
 * @param groupId - ID of the group requested to join.
 * @fqn wix.social.groups.api.v2.JoinGroupRequestsService.ListJoinGroupRequests
 */
async function listJoinGroupRequests(groupId, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        groupId: groupId,
        limit: options?.limit,
        offset: options?.offset,
    });
    const reqOpts = ambassadorWixSocialGroupsV2JoinGroupRequest.listJoinGroupRequests(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                groupId: '$[0]',
                limit: '$[1].limit',
                offset: '$[1].offset',
            },
            singleArgumentUnchanged: false,
        }, ['groupId', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.listJoinGroupRequests = listJoinGroupRequests;
/**
 * Creates a query to retrieve a list of join requests.
 *
 * > **Notes:**
 * > + This function is only relevant for private groups.
 * > + For `SECRET` groups, only group admins can query requests to join their group. <!-- However, if the `suppressAuth` option is set to `true`, all permissions are overwritten, and all site members (including non-group members) can query requests to join a group. -->
 *
 * The `queryjoinGroupRequests()` function builds a query to retrieve a list of all requests to join a group, and returns a `JoinGroupRequestsQueryBuilder` object.
 *
 * The returned object contains the query definition which is typically used to run the query using the [`find()`](/join-group-requests-query-builder/find) function.
 *
 * You can refine the query by chaining `joinGroupRequestsQueryBuilder` functions onto the query. `joinGroupRequestsQueryBuilder` functions enable you to sort, filter, and control the results that `queryjoinGroupRequests()` returns.
 *
 * The results of the `queryjoinGroupRequests()` function are sorted by `_createdDate` in descending order.
 *
 * `queryjoinGroupRequests()` runs with this `joinGroupRequestsQueryBuilder` default, which you can override:
 * + [`limit(100)`](/join-group-requests-query-builder/limit)
 *
 * The following `joinGroupRequestsQueryBuilder` functions are supported for `queryjoinGroupRequests()`. For a full description of the joinGroupRequests object, see the object returned for the [`items`](/join-group-requests-query-result/items) property in `JoinGroupRequestsQueryResult`.
 *
 * @public
 * @requiredField groupId
 * @param groupId - Group ID.
 * @fqn wix.social.groups.api.v2.JoinGroupRequestsService.QueryJoinGroupRequests
 */
function queryJoinGroupRequests(groupId, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    return (0, query_builder_1.queryBuilder)({
        func: async (payload) => {
            const reqOpts = ambassadorWixSocialGroupsV2JoinGroupRequest.queryJoinGroupRequests({
                ...payload,
                ...(options ?? {}),
                groupId,
            });
            sideEffects?.onSiteCall?.();
            try {
                const result = await httpClient.request(reqOpts);
                sideEffects?.onSuccess?.(result);
                return result;
            }
            catch (err) {
                sideEffects?.onError?.(err);
                throw err;
            }
        },
        requestTransformer: (query) => {
            const args = [query, groupId, options];
            return (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
                groupId: args?.[1],
                ...args?.[2],
                query: args?.[0],
            });
        },
        responseTransformer: ({ data, }) => {
            const transformedData = (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(data, []));
            return {
                items: transformedData?.joinGroupRequests,
                pagingMetadata: transformedData?.metadata,
            };
        },
        errorTransformer: (err) => {
            const transformedError = (0, transform_error_1.transformError)(err, {
                spreadPathsToArguments: {},
                explicitPathsToArguments: { groupId: '$[1]', query: '$[0]' },
                singleArgumentUnchanged: false,
            });
            throw transformedError;
        },
        pagingMethod: 'OFFSET',
        transformationPaths: {},
    });
}
exports.queryJoinGroupRequests = queryJoinGroupRequests;
//# sourceMappingURL=social-groups-v2-join-group-request-join-group-requests.universal.js.map