"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebhookIdentityType = exports.ViolationType = exports.SortOrder = exports.RequestStatus = exports.OwnershipFilter = exports.ItemsToUpdate = exports.onJoinGroupRequestRejected = exports.onJoinGroupRequestCreated = exports.onJoinGroupRequestApproved = exports.queryJoinGroupRequests = exports.listJoinGroupRequests = exports.rejectJoinGroupRequests = exports.approveJoinGroupRequests = exports.__metadata = void 0;
const rename_all_nested_keys_1 = require("@wix/sdk-runtime/rename-all-nested-keys");
const timestamp_1 = require("@wix/sdk-runtime/transformations/timestamp");
const transform_paths_1 = require("@wix/sdk-runtime/transformations/transform-paths");
const sdk_types_1 = require("@wix/sdk-types");
const social_groups_v2_join_group_request_join_group_requests_universal_js_1 = require("./social-groups-v2-join-group-request-join-group-requests.universal.js");
exports.__metadata = { PACKAGE_NAME: '@wix/groups' };
function approveJoinGroupRequests(httpClient) {
    return (groupId, memberIds) => (0, social_groups_v2_join_group_request_join_group_requests_universal_js_1.approveJoinGroupRequests)(groupId, memberIds, 
    // @ts-ignore
    { httpClient });
}
exports.approveJoinGroupRequests = approveJoinGroupRequests;
function rejectJoinGroupRequests(httpClient) {
    return (groupId, rejections) => (0, social_groups_v2_join_group_request_join_group_requests_universal_js_1.rejectJoinGroupRequests)(groupId, rejections, 
    // @ts-ignore
    { httpClient });
}
exports.rejectJoinGroupRequests = rejectJoinGroupRequests;
function listJoinGroupRequests(httpClient) {
    return (groupId, options) => (0, social_groups_v2_join_group_request_join_group_requests_universal_js_1.listJoinGroupRequests)(groupId, options, 
    // @ts-ignore
    { httpClient });
}
exports.listJoinGroupRequests = listJoinGroupRequests;
function queryJoinGroupRequests(httpClient) {
    return (groupId, options) => (0, social_groups_v2_join_group_request_join_group_requests_universal_js_1.queryJoinGroupRequests)(groupId, options, 
    // @ts-ignore
    { httpClient });
}
exports.queryJoinGroupRequests = queryJoinGroupRequests;
exports.onJoinGroupRequestApproved = (0, sdk_types_1.EventDefinition)('wix.social_groups.v2.join_group_request_approved', true, (event) => (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(event, [
    {
        transformFn: timestamp_1.transformRESTTimestampToSDKTimestamp,
        paths: [
            { path: 'data.joinGroupRequest.createdDate' },
            { path: 'metadata.eventTime' },
        ],
    },
])))();
exports.onJoinGroupRequestCreated = (0, sdk_types_1.EventDefinition)('wix.social_groups.v2.join_group_request_created', true, (event) => (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(event, [
    {
        transformFn: timestamp_1.transformRESTTimestampToSDKTimestamp,
        paths: [
            { path: 'entity.createdDate' },
            { path: 'metadata.eventTime' },
        ],
    },
])))();
exports.onJoinGroupRequestRejected = (0, sdk_types_1.EventDefinition)('wix.social_groups.v2.join_group_request_rejected', true, (event) => (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(event, [
    {
        transformFn: timestamp_1.transformRESTTimestampToSDKTimestamp,
        paths: [
            { path: 'data.joinGroupRequest.createdDate' },
            { path: 'metadata.eventTime' },
        ],
    },
])))();
var social_groups_v2_join_group_request_join_group_requests_universal_js_2 = require("./social-groups-v2-join-group-request-join-group-requests.universal.js");
Object.defineProperty(exports, "ItemsToUpdate", { enumerable: true, get: function () { return social_groups_v2_join_group_request_join_group_requests_universal_js_2.ItemsToUpdate; } });
Object.defineProperty(exports, "OwnershipFilter", { enumerable: true, get: function () { return social_groups_v2_join_group_request_join_group_requests_universal_js_2.OwnershipFilter; } });
Object.defineProperty(exports, "RequestStatus", { enumerable: true, get: function () { return social_groups_v2_join_group_request_join_group_requests_universal_js_2.RequestStatus; } });
Object.defineProperty(exports, "SortOrder", { enumerable: true, get: function () { return social_groups_v2_join_group_request_join_group_requests_universal_js_2.SortOrder; } });
Object.defineProperty(exports, "ViolationType", { enumerable: true, get: function () { return social_groups_v2_join_group_request_join_group_requests_universal_js_2.ViolationType; } });
Object.defineProperty(exports, "WebhookIdentityType", { enumerable: true, get: function () { return social_groups_v2_join_group_request_join_group_requests_universal_js_2.WebhookIdentityType; } });
//# sourceMappingURL=social-groups-v2-join-group-request-join-group-requests.public.js.map