import { approveJoinGroupRequests as publicApproveJoinGroupRequests, rejectJoinGroupRequests as publicRejectJoinGroupRequests, listJoinGroupRequests as publicListJoinGroupRequests, queryJoinGroupRequests as publicQueryJoinGroupRequests } from './social-groups-v2-join-group-request-join-group-requests.public.js';
import { createEventModule } from '@wix/sdk-runtime/event-definition-modules';
import { BuildRESTFunction, MaybeContext } from '@wix/sdk-types';
import { onJoinGroupRequestApproved as publicOnJoinGroupRequestApproved } from './social-groups-v2-join-group-request-join-group-requests.public.js';
import { onJoinGroupRequestCreated as publicOnJoinGroupRequestCreated } from './social-groups-v2-join-group-request-join-group-requests.public.js';
import { onJoinGroupRequestRejected as publicOnJoinGroupRequestRejected } from './social-groups-v2-join-group-request-join-group-requests.public.js';
export declare const approveJoinGroupRequests: MaybeContext<BuildRESTFunction<typeof publicApproveJoinGroupRequests> & typeof publicApproveJoinGroupRequests>;
export declare const rejectJoinGroupRequests: MaybeContext<BuildRESTFunction<typeof publicRejectJoinGroupRequests> & typeof publicRejectJoinGroupRequests>;
export declare const listJoinGroupRequests: MaybeContext<BuildRESTFunction<typeof publicListJoinGroupRequests> & typeof publicListJoinGroupRequests>;
export declare const queryJoinGroupRequests: MaybeContext<BuildRESTFunction<typeof publicQueryJoinGroupRequests> & typeof publicQueryJoinGroupRequests>;
/**
 * Triggered when a join group request is approved.
 */
export declare const onJoinGroupRequestApproved: ReturnType<typeof createEventModule<typeof publicOnJoinGroupRequestApproved>>;
/** */
export declare const onJoinGroupRequestCreated: ReturnType<typeof createEventModule<typeof publicOnJoinGroupRequestCreated>>;
/**
 * Triggered when a join group request is rejected.
 */
export declare const onJoinGroupRequestRejected: ReturnType<typeof createEventModule<typeof publicOnJoinGroupRequestRejected>>;
export { RequestStatus, ViolationType, ItemsToUpdate, OwnershipFilter, SortOrder, WebhookIdentityType, } from './social-groups-v2-join-group-request-join-group-requests.universal.js';
export { JoinGroupRequest, RequestDetails, SocialGroupsEvent, SocialGroupsEventPayloadOneOf, MemberJoinedGroup, MembersAddedToGroup, JoinRequestsApproved, MembersInvitedToGroup, GetJoinRequirementsRequest, MembershipQuestionAnswer, GetJoinRequirementsResponse, PaidPlan, EventsViolationOptions, PricingPlanViolationOptions, MembershipQuestionViolationOptions, Violation, ViolationViolationOptionsOneOf, SubmitJoinGroupRequestRequest, SubmitJoinGroupRequestResponse, CancelJoinGroupRequestRequest, CancelJoinGroupRequestResponse, JoinGroupRequestCancelled, ApproveJoinGroupRequestsRequest, ApproveJoinGroupRequestsResponse, JoinGroupRequestApproved, RejectJoinGroupRequestsRequest, Rejection, RejectJoinGroupRequestsResponse, JoinGroupRequestRejected, ListJoinGroupRequestsRequest, ListJoinGroupRequestsResponse, PagingMetadata, QueryJoinGroupRequestsRequest, Query, Sorting, Paging, QueryJoinGroupRequestsResponse, RejectAllJoinGroupRequestsRequest, RejectAllJoinGroupRequestsResponse, ApproveAllJoinGroupRequestsRequest, ApproveAllJoinGroupRequestsResponse, ListAllJoinGroupRequestsRequest, ListAllJoinGroupRequestsResponse, DomainEvent, DomainEventBodyOneOf, EntityCreatedEvent, RestoreInfo, EntityUpdatedEvent, EntityDeletedEvent, ActionEvent, MessageEnvelope, IdentificationData, IdentificationDataIdOneOf, BaseEventMetadata, EventMetadata, JoinGroupRequestApprovedEnvelope, JoinGroupRequestCreatedEnvelope, JoinGroupRequestRejectedEnvelope, ListJoinGroupRequestsOptions, QueryJoinGroupRequestsOptions, JoinGroupRequestsQueryResult, JoinGroupRequestsQueryBuilder, } from './social-groups-v2-join-group-request-join-group-requests.universal.js';
