import { renameKeysFromRESTResponseToSDKResponse } from '@wix/sdk-runtime/rename-all-nested-keys';
import { transformRESTTimestampToSDKTimestamp } from '@wix/sdk-runtime/transformations/timestamp';
import { transformPaths } from '@wix/sdk-runtime/transformations/transform-paths';
import { EventDefinition } from '@wix/sdk-types';
import { approveJoinGroupRequests as universalApproveJoinGroupRequests, listJoinGroupRequests as universalListJoinGroupRequests, queryJoinGroupRequests as universalQueryJoinGroupRequests, rejectJoinGroupRequests as universalRejectJoinGroupRequests, } from './social-groups-v2-join-group-request-join-group-requests.universal.js';
export const __metadata = { PACKAGE_NAME: '@wix/groups' };
export function approveJoinGroupRequests(httpClient) {
    return (groupId, memberIds) => universalApproveJoinGroupRequests(groupId, memberIds, 
    // @ts-ignore
    { httpClient });
}
export function rejectJoinGroupRequests(httpClient) {
    return (groupId, rejections) => universalRejectJoinGroupRequests(groupId, rejections, 
    // @ts-ignore
    { httpClient });
}
export function listJoinGroupRequests(httpClient) {
    return (groupId, options) => universalListJoinGroupRequests(groupId, options, 
    // @ts-ignore
    { httpClient });
}
export function queryJoinGroupRequests(httpClient) {
    return (groupId, options) => universalQueryJoinGroupRequests(groupId, options, 
    // @ts-ignore
    { httpClient });
}
export const onJoinGroupRequestApproved = EventDefinition('wix.social_groups.v2.join_group_request_approved', true, (event) => renameKeysFromRESTResponseToSDKResponse(transformPaths(event, [
    {
        transformFn: transformRESTTimestampToSDKTimestamp,
        paths: [
            { path: 'data.joinGroupRequest.createdDate' },
            { path: 'metadata.eventTime' },
        ],
    },
])))();
export const onJoinGroupRequestCreated = EventDefinition('wix.social_groups.v2.join_group_request_created', true, (event) => renameKeysFromRESTResponseToSDKResponse(transformPaths(event, [
    {
        transformFn: transformRESTTimestampToSDKTimestamp,
        paths: [
            { path: 'entity.createdDate' },
            { path: 'metadata.eventTime' },
        ],
    },
])))();
export const onJoinGroupRequestRejected = EventDefinition('wix.social_groups.v2.join_group_request_rejected', true, (event) => renameKeysFromRESTResponseToSDKResponse(transformPaths(event, [
    {
        transformFn: transformRESTTimestampToSDKTimestamp,
        paths: [
            { path: 'data.joinGroupRequest.createdDate' },
            { path: 'metadata.eventTime' },
        ],
    },
])))();
export { ItemsToUpdate, OwnershipFilter, RequestStatus, SortOrder, ViolationType, WebhookIdentityType, } from './social-groups-v2-join-group-request-join-group-requests.universal.js';
//# sourceMappingURL=social-groups-v2-join-group-request-join-group-requests.public.js.map